
/*              DEMO.C -- Demo program for FONTLIB            */
/*              Copyright (c) 1993 Joseph V. Gagliano         */

#include <graph.h>
#include <conio.h>
#include "fontlib.h"


#define SLATE   0x18130eL
#define OLIVE   0x162015L


main()
{
	int num_keys;
	int i;
	struct videoconfig vid_info;
	short videomode;
	short xmax,xmin,ymax,ymin;
	char text[5];

	_getvideoconfig(&vid_info);

	switch(vid_info.adapter)
	{
		case _EGA:
			videomode = _ERESCOLOR;
			break;
		case _VGA:
			videomode = _VRES16COLOR;
			break;
		default:
			printf("\nThis program requires EGA 640x350 16 color graphics support!");
			exit(0);
			break;
	}





	_setvideomode(videomode);

	_getvideoconfig(&vid_info);

	xmin = 0;
	ymin = 0;
	xmax = vid_info.numxpixels;
	ymax = vid_info.numypixels;
	/********border/background************/
	_clearscreen(_GCLEARSCREEN);
	_setbkcolor(SLATE);
	_setcolor(3);
	_rectangle(_GBORDER,xmin,ymin,xmax,ymax);
	_rectangle(_GBORDER,xmin+2,ymin+2,xmax-2,ymax-2);
	_floodfill(xmin+1,ymin+1,3);
	_rectangle(_GFILLINTERIOR,xmin+2,ymin+98,xmax-2,ymin+100);
	_setcolor(8);
	_floodfill(xmin+5,ymin+5,3);
	_setcolor(11);
	_rectangle(_GFILLINTERIOR,xmin+20,ymin+30,xmin+200,ymin+50);
	_rectangle(_GFILLINTERIOR,xmax-20,ymin+30,xmax-200,ymin+50);
	_setcolor(12);
	_rectangle(_GFILLINTERIOR,xmin+20,ymin+70,xmin+150,ymin+90);
	_rectangle(_GFILLINTERIOR,xmax-20,ymin+70,xmax-150,ymin+90);

	/********title************/
	num_keys = regfont("20X20.fon");
	set_font_color(15);
	set_shadow_color(7);

	letter(225,50,"F\x27-O\x27-N\x27-T\x27+L\x27+I\x27+B\x27+  V1.1",RIGHT,-5,SHAD2);
	freefont();
	num_keys = regfont("20X12.fon");
	set_font_color(9);
	set_shadow_color(1);
	letter(170,90,"1993 Joseph V. Gagliano",RIGHT,S0,SHAD1);
	freefont();

	/********first page************/
	_setviewport(xmin+3,ymin+101,xmax-3,ymax-3);
	_setwindow(1,-1,-1,101,101);
	num_keys = regfont("13X8.fon");
	set_font_color(14);
	set_shadow_color(6);
	letter_w(10,90,"The FONTLIB library contains 13 functions that provide fast",RIGHT,S0,SHADOFF);
	letter_w(10,85,"and easy display font capabilities to the C programmer.",RIGHT,S0,SHADOFF);
	letter_w(10,80,"Since the fonts are user-defined, YOU can determine the size",RIGHT,S0,SHADOFF);
	letter_w(10,75,"(up to 60 pixels high by 30 pixels wide) and shape you want.",RIGHT,S0,SHADOFF);
	letter_w(10,65,"FONTLIB works best in applications that use mono or color",RIGHT,S0,SHADOFF);
	letter_w(10,60,"EGA or VGA graphics with resolutions of 640*350 or better.",RIGHT,S0,SHADOFF);
	letter_w(10,50,"Features of the FONTLIB library:",RIGHT,S0,SHADOFF);
	_setcolor(7);
	_rectangle_w(_GFILLINTERIOR,12,46,91,4);
	_setcolor(3);
	_rectangle_w(_GFILLINTERIOR,10,48,90,5);
	set_font_color(15);
	letter_w(20,40,"\x27-\x27+ draw letters/symbols or strings on the screen",RIGHT,S0,SHADOFF);
	letter_w(20,35,"  in any graphics mode or window setup.",RIGHT,S0,SHADOFF);
	letter_w(20,28,"\x27-\x27+ control over font spacing.",RIGHT,S0,SHADOFF);
	letter_w(20,21,"\x27-\x27+ draw in portrait, landscape, or columnar.",RIGHT,S0,SHADOFF);
	set_shadow_color(8);
	letter_w(20,14,"\x27-\x27+ add shadows to letters/symbols or strings.",RIGHT,S0,SHAD1);
	letter_w(20,7,"\x27s\x27-\x27+ change \x27-c\x27-o\x27-l\x27-o\x27-r\x27-s \x27+\x27+\x27+\x27+\x27+\x27+and toggle \x27Sshadows\x27s inline.",RIGHT,S0,SHAD2);
	letter_bold_w(50,.05,"HIT ANY KEY",RIGHT,S2,SHADOFF);

	getch();
	getch();


	_clearscreen(_GVIEWPORT);

	/********second page************/
	set_font_color(14);
	letter_w(5,95,"FONTLIB Library Functions:",RIGHT,S0,SHADOFF);
	freefont();
	num_keys = regfont("8x5.fon");
	letter_w(10,85,"\x27-\x27+ regfont              - Registers a font file and allocates memory.",RIGHT,S1,SHADOFF);
	letter_w(10,80,"\x27-\x27+ freefont             - Frees memory allocated by regfont.",RIGHT,S1,SHADOFF);
	letter_w(10,75,"\x27-\x27+ draw_letter          - Draws a letter/symbol to the screen.",RIGHT,S1,SHADOFF);
	letter_w(10,70,"\x27-\x27+ draw_letter_bold     - Draws a bold letter/symbol to the physical screen.",RIGHT,S1,SHADOFF);
	letter_w(10,65,"\x27-\x27+ letter               - Draws a string of letters/symbols to the physical screen.",RIGHT,S1,SHADOFF);
	letter_w(10,60,"\x27-\x27+ letter_bold          - Draws a string of bold letters/symbols to the physical screen.",RIGHT,S1,SHADOFF);
	letter_w(10,55,"\x27-\x27+ letter_w             - Draws a string of letters/symbols to the physical screen given",RIGHT,S1,SHADOFF);
      letter_w(10,52.5,"                         window coordinates.",RIGHT,S1,SHADOFF);
      letter_w(10,47.5,"\x27-\x27+ letter_bold_w        - Draws a string of bold letters/symbols to the physical screen",RIGHT,S1,SHADOFF);
	letter_w(10,45,"                         given window coordinates.",RIGHT,S1,SHADOFF);
	letter_w(10,40,"\x27-\x27+ letter_column        - Draws a string of letters/symbols to the physical screen",RIGHT,S1,SHADOFF);
      letter_w(10,37.5,"                         in columnar format.",RIGHT,S1,SHADOFF);
      letter_w(10,32.5,"\x27-\x27+ letter_column_bold   - Draws a string of bold letters/symbols to the physical screen",RIGHT,S1,SHADOFF);
	letter_w(10,30,"                         in columnar format.",RIGHT,S1,SHADOFF);
	letter_w(10,25,"\x27-\x27+ letter_column_w      - Draws a string of letters/symbols to the physical screen",RIGHT,S1,SHADOFF);
      letter_w(10,22.5,"                         in columnar format given window coordinates.",RIGHT,S1,SHADOFF);
      letter_w(10,17.5,"\x27-\x27+ letter_column_bold_w - Draws a string of bold letters/symbols to the physical screen",RIGHT,S1,SHADOFF);
	letter_w(10,15,"                         in columnar format given window coordinates.",RIGHT,S1,SHADOFF);
	letter_w(10,10,"\x27-\x27+ set_shadow_color     - Sets the color to be used for shadows.",RIGHT,S1,SHADOFF);
	letter_bold_w(50,.5,"HIT ANY KEY",RIGHT,S2,SHADOFF);

	getch();
	getch();
	_setbkcolor(OLIVE);
	_clearscreen(_GVIEWPORT);

	/********third page************/
	_setcolor(8);
	_moveto_w(18,45);
	_lineto_w(53,45);
	_moveto_w(35,70);
	_lineto_w(35,15);

	set_font_color(15);
	set_shadow_color(6);
	letter_w(5,90,"\"letter\" DEMO",RIGHT,S1,SHADOFF);
	letter_w(5,87.5,"\"letter_w\" DEMO",RIGHT,S1,SHADOFF);
	letter_w(5,85,"\"letter_bold_w\" DEMO",RIGHT,S1,SHADOFF);
	set_font_color(14);
	letter_w(5,80,"Characters on this line separated by 3 pixels.",RIGHT,S3,SHADOFF);
	letter_w(5,75,"This line has no shading.",RIGHT,S1,SHADOFF);
	letter_w(5,72.5,"This line has shading to 3 pixel depth.",RIGHT,S1,SHAD3);
	letter_bold_w(5,67.5,"THIS LINE IS BOLD.",RIGHT,S1,SHADOFF);
	set_font_color(4);
	_setviewport(xmin,ymin,xmax,ymax);
	letter(500,400,".(500,400) physical",RIGHT,S1,SHADOFF);
	_setviewport(xmin+3,ymin+101,xmax-3,ymax-3);
	set_font_color(14);
	letter_w(80,10,".(80.0,10.0) window",RIGHT,S1,SHADOFF);

	set_font_color(13);
	_ellipse_w(_GFILLINTERIOR,-.5,.5*(xmax/ymax),.5,-.5*(xmax/ymax));
	_ellipse_w(_GFILLINTERIOR,-.5,100.5*(xmax/ymax),.5,99.5*(xmax/ymax));
	_ellipse_w(_GFILLINTERIOR,99.5,100.5*(xmax/ymax),100.5,99.5*(xmax/ymax));
	_ellipse_w(_GFILLINTERIOR,99.5,.5*(xmax/ymax),100.5,-.5*(xmax/ymax));
	letter_w(.5,1,"(0,0)",RIGHT,S0,SHADOFF);
	letter_w(.5,97,"(0,100)",RIGHT,S0,SHADOFF);
	letter_w(93,97,"(100,100)",RIGHT,S0,SHADOFF);
	letter_w(95,1,"(100,0)",RIGHT,S0,SHADOFF);
	set_font_color(1);
	letter_w(35,45," RIGHT  =  0",RIGHT,S1,SHADOFF);
	letter_w(35,45," UP  =  90",UP,S1,SHADOFF);
	letter_w(35,45," LEFT  =  180",LEFT,S1,SHADOFF);
	letter_w(35,45," DOWN  =  270",DOWN,S1,SHADOFF);

	_setcolor(3);
	_rectangle_w(_GFILLINTERIOR,55,80,95,30);
	set_font_color(11);
	set_shadow_color(7);
	letter_w(60,50,"Y AXIS",UP,S1,SHADOFF);
	letter_w(72,33,"X AXIS",RIGHT,S1,SHADOFF);
	_setcolor(8);
	_moveto_w(65,75);
	_lineto_w(65,40);
	_lineto_w(85,40);
	_setcolor(14);
	for(i=75;i>40;i=i-5)
	{
	   _moveto_w(65,i);
	   _lineto_w(66,i);
	   sprintf(text,"%d",i-40);
	   letter_w(62,i-.2,text,RIGHT,S0,SHADOFF);
	}
	letter_w(63,39,"0",RIGHT,S0,SHADOFF);
	for(i=85;i>65;i=i-2.5)
	{
	   _moveto_w(i,40);
	   _lineto_w(i,41);
	   sprintf(text,"%d",i-65);
	   letter_w(i-.3,37,text,RIGHT,S0,SHADOFF);
	}

	_setcolor(10);
	_moveto_w(65,40);
	_lineto_w(70,50);
	_lineto_w(75,62);
	_lineto_w(78,45);
	_lineto_w(81,74);
	_lineto_w(82,60);
	_lineto_w(85,54);

	letter_bold_w(50,.5,"HIT ANY KEY",RIGHT,S2,SHADOFF);

	getch();
	getch();
	_clearscreen(_GVIEWPORT);

	/********fourth page************/
	set_font_color(15);
	letter_w(5,90,"\"letter_column\" DEMO",RIGHT,S1,SHADOFF);
	letter_w(5,87.5,"\"letter_column_w\" DEMO",RIGHT,S1,SHADOFF);
	letter_w(5,85,"\"letter_column_bold_w\" DEMO",RIGHT,S1,SHADOFF);
	letter_column_w(20,80,"Columns look like this!",SHADOFF);
	letter_column_bold_w(25,80,"BOLD COLUMNS LOOK LIKE THIS!",SHADOFF);

	_setcolor(3);
	_rectangle_w(_GFILLINTERIOR,55,85,95,30);
	set_font_color(11);

	set_shadow_color(7);
	letter_column_w(60,68,"Y AXIS",SHADOFF);
	letter_w(72,33,"X AXIS",RIGHT,S1,SHADOFF);
	_setcolor(8);
	_moveto_w(65,75);
	_lineto_w(65,40);
	_lineto_w(85,40);
	_setcolor(14);
	for(i=75;i>40;i=i-5)
	{
	   _moveto_w(65,i);
	   _lineto_w(66,i);
	   sprintf(text,"%d",i-40);
	   letter_w(62,i-.2,text,RIGHT,S0,SHADOFF);

	}
	letter_w(63,39,"0",RIGHT,S0,SHADOFF);
	for(i=85;i>65;i=i-2.5)
	{
	   _moveto_w(i,40);
	   _lineto_w(i,41);
	   sprintf(text,"%d",i-65);
	   letter_w(i-.3,37,text,RIGHT,S0,SHADOFF);

	}

	_setcolor(10);
	_moveto_w(65,40);
	_lineto_w(70,50);
	_lineto_w(75,62);
	_lineto_w(78,45);
	_lineto_w(81,74);
	_lineto_w(82,60);
	_lineto_w(85,54);

	set_font_color(14);
	set_shadow_color(6);
	letter_column_w(30,80,"Brown shadow",SHAD1);
	letter_column_w(35,80,"Tall Brown shadow",5);
	_setviewport(xmin,ymin,xmax,ymax);
	set_font_color(12);
	set_shadow_color(4);
	letter_column_bold(320,300,"HIT\x27- ANY KEY",SHAD2);



	freefont();

	getch();
	getch();

	_setvideomode(_DEFAULTMODE);

	/*getch();
	getch();
	*/
}


